<script>
  import { user, authToken, views } from '../../store'
  import { push, location } from 'svelte-spa-router'
  import { getLabel, buildURL } from '../../utils/view-helper'
  import logo from '../../images/supernova_4.png'

  let modalClass = ''

  function logout ($event) {
    $event.preventDefault()
    user.set(null)
    authToken.set(null)
    localStorage.removeItem('user')
    localStorage.removeItem('authToken')
    push('/login')
  }

  function toggleCredits () {
    modalClass = !modalClass ? 'is-active' : ''
  }
</script>

<nav class="navbar flex flex-column">
  <div class="navbar-header p-4 flex items-center justify-center">
    <div class="logo">
      <img src={logo} alt="Supernova">
    </div>
    Supernova
  </div>

  <div class="navbar-body flex-grow has-auto-scroll">
    <ul>
      {#if $views}
        {#each $views as item}
          {#if item.showOnMenu}
            <li>
              <a href="#/admin{item.slug}" class="navbar-item rounded {`/admin${item.slug}` === $location ? 'is-active' : ''}">{getLabel(item.labelKey)}</a>
            </li>
          {/if}
        {/each}
      {/if}
    </ul>
  </div>

  <div class="navbar-footer p-4">
    {#if $user}
      <div class="flex items-center">
        {#if $user.photo}
          <div class="pr-2">
            <figure class="image is-32x32">
              <img src={buildURL($user.photo)} alt="" class="is-rounded">
            </figure>
          </div>
        {/if}

        <div class="flex-grow text-ellipsis">
          <a href="#/admin/users_form/{$user.id}" class="has-text-link"><b>{$user.name}</b></a>
          <div>
            <small>{$user.email}</small>
          </div>
        </div>
        <a href="#/" on:click={logout} class="has-text-danger">Logout</a>
      </div>
    {/if}
  </div>

  <div class="navbar-credits has-text-centered p-1" on:click={toggleCredits}>
    Made with ♥ - Credits ©
  </div>
</nav>

<div class="modal {modalClass}">
  <div class="modal-background"></div>
  <div class="modal-card">
    <header class="modal-card-head">
      <p class="modal-card-title">Credits</p>
      <button class="delete" aria-label="close" on:click={toggleCredits}></button>
    </header>

    <section class="modal-card-body">
      <p>
        Supernova Logo made by <a href="https://www.flaticon.com/authors/eucalyp" title="Eucalyp">Eucalyp</a> from <a href="https://www.flaticon.com/" title="Flaticon">www.flaticon.com</a>
      </p>

      <p>Bulma CSS framework: <a href="https://bulma.io">https://bulma.io</a></p>
      <p>Sequelize ORM: <a href="https://sequelize.org/">https://sequelize.org/</a></p>
      <p>ExpressJS: <a href="https://expressjs.com/">https://expressjs.com/</a></p>
    </section>

    <footer class="modal-card-foot">
      <button class="button" on:click={toggleCredits}>Close</button>
    </footer>
  </div>
</div>
